require "util"
--require "story"
require "defines"


remote.addinterface("treefarm", {
   cleartable = function()
        while (glob.field[1] ~= nil) do
            table.remove(glob.field)
        end
        glob.fieldcount = 0  
    end
 })



game.oninit(function()
  glob.field = {}
  glob.fieldcount= 0 
  glob.tickCount = 0
end)


game.onevent(defines.events.onbuiltentity, function(event)
  if event.createdentity.name == "field" then
    glob.fieldcount = glob.fieldcount + 1    
    glob.field[glob.fieldcount] = event.createdentity
  end
end)

game.onevent(defines.events.ontick, function(event)
    glob.tickCount = glob.tickCount + 1
    if glob.tickCount % 600 == 0 and glob.fieldcount ~= 0 then     -- called every 10 sec and at least 1 field is placed
        for k,v in pairs(glob.field) do --run through field entities
            if not v.isvalid() then --actual field exists
                table.remove(glob.field, k) --if not then remove
                glob.fieldcount=glob.fieldcount-1 --and decrement count
            else
                local grow = math.ceil(game.getrandomnumber()*10) -- random tree spawning (without fertilizer)
                if v.getitemcount("fertilizer") > 0 then-- with fertilizer: tree spawn every update-cycle (only if enough space)
                    grow = 10
                    v.getinventory(1).remove{name = "fertilizer", count = 1}
                end
                if grow > 9 then
                    local pos, pose, posz = {}, {}, {}
                    pos.x = v.position.x + math.ceil(game.getrandomnumber() * 6.5)
                    pos.y = v.position.y + math.ceil(game.getrandomnumber() * 6)
                    pose.x, pose.y, posz.x, posz.y = pos.x - 0.25, pos.y - 0.25, pos.x + 0.25, pos.y + 0.25
                    local entities = game.findentities{pose, posz}
                    if not entities[1] then game.createentity{name="big-tree", position = pos} end
                end
                    --Tree Harvesting
                local relpos = {}
                relpos.x, relpos.y = v.position.x + 8, v.position.y + 8
                local entities = game.findentities{v.position, relpos}
                local t = 0
                for k,v in pairs(entities) do
                    if v.type == "tree" then
                        t=t+1
                    end
                end
                if t > 4 and v.getitemcount("raw-wood") < 128 then
                    local rndz, rndd = math.ceil(game.getrandomnumber() * t), 0 --tried game.getrandomnumber and it get saying wrong number of args so...
                    if v.getitemcount("fertilizer") then
                        rndd = math.ceil(game.getrandomnumber() * 6)
                    else
                        rndd = math.ceil(game.getrandomnumber() *3)
                    end
                    if entities[rndz].type == "tree" then
                        entities[rndz].destroy()
                        v.getinventory(1).insert{name="raw-wood", count=rndd}
                    end
                end
            end
        end
    end
end)
